<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="text" encoding="UTF-8" />

  <xsl:variable name="monthnames">
    <month number="1">January</month>
    <month number="2">Febuary</month>
    <month number="3">March</month>
    <month number="4">April</month>
    <month number="5">May</month>
    <month number="6">June</month>
    <month number="7">July</month>
    <month number="8">August</month>
    <month number="9">September</month>
    <month number="10">October</month>
    <month number="11">November</month>
    <month number="12">December</month>
  </xsl:variable>

  <xsl:template match="/">
    <xsl:call-template name="formatdate" />
  </xsl:template>

  <xsl:template name="formatdate">
    <xsl:param name="datetime" select="." />
    <xsl:variable name="year" select="number(substring-before($datetime,'-'))" />
    <xsl:variable name="month" select="number(substring($datetime,6,2))" />
    <xsl:variable name="day" select="number(substring($datetime,9,2))" />
    <xsl:text>Today is </xsl:text>
    <xsl:value-of select="$monthnames/month[@number=$month]" />
    <xsl:text> </xsl:text><xsl:value-of select="$day" />
    <xsl:text>, </xsl:text><xsl:value-of select="$year" />
    <xsl:text>.</xsl:text>
  </xsl:template>
</xsl:stylesheet>