<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="html" version="4.0" encoding="UTF-8" />
  <xsl:strip-space elements="article body" />

  <xsl:template match="/">
    <html>
      <body>
        <xsl:apply-templates />
      </body>
    </html>
  </xsl:template>

  <xsl:template match="article">
    <xsl:call-template name="info" />
    <h2>Abstract</h2>
    <p><xsl:apply-templates select="intro" /></p>
    <h2>Table Of Contents</h2>
    <xsl:apply-templates mode="toc" />
    <hr />
    <xsl:apply-templates mode="body" />
  </xsl:template>

  <xsl:template name="info">
    <h1><xsl:value-of select="title" /></h1>
    <p>
      Written <xsl:value-of select="@date" />
      by <i>
        <xsl:value-of select="author/@firstname" />
        <xsl:text> </xsl:text>
        <xsl:value-of select="author/@lastname" />
      </i>
    </p>
  </xsl:template>

  <xsl:template match="intro">
    <xsl:apply-templates />
  </xsl:template>

  <xsl:template match="term">
    <u><xsl:value-of select="." /></u>
  </xsl:template>

  <xsl:template match="text()">
     <xsl:value-of select="." />
  </xsl:template>

  <xsl:template match="body" mode="toc">
    <xsl:apply-templates mode="toc" />
  </xsl:template>

  <xsl:template match="para" mode="toc">
    <xsl:if test="@header">
      <a href="#{@header}">
        <xsl:value-of select="@header" />
      </a><br /><xsl:text>&#xA;</xsl:text>
    </xsl:if>
  </xsl:template>

  <xsl:template match="*" />
  <xsl:template match="*" mode="toc" />
  <xsl:template match="*" mode="body" />
</xsl:stylesheet>
